﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Gifitti.Models;
using GifittiUnitTest.Helper;
namespace GifittiUnitTest.SubGif
{ 

    [TestClass]
    public class SubGifUnitTest
    {
        private const string TEMP_OUT = @"TEMP_GIF_SUB_GIF.gif";
        [TestMethod]
        public void SubGifValidation()
        {
            //Load GM model of Input
            GifModel gmInput = new GifModel(UnitTestHelper.INPUT_GIF);
            gmInput.startFrame = 10;
            gmInput.endFrame = 16;
            gmInput.saveGif(TEMP_OUT);

            //Compare actual versus expected
            GifModel gmExpected = new GifModel(UnitTestHelper.SUB_GIF_EXPECTED);
            GifModel gmActual = new GifModel(TEMP_OUT);

            if (gmExpected.numberOfFrames != gmActual.numberOfFrames)
                Assert.Fail(@"# FRAMES MISMATCH");
            for(int i = gmExpected.startFrame; i < gmExpected.numberOfFrames; i++)
            {
                if (!UnitTestHelper.PxByPxCompare(gmExpected.gifImage, gmActual.gifImage))
                    Assert.Fail(@"Failue on Frame {0}, NOT EQUAL", i);
            }
            //PASS
        }
    }
}
